<?php
////////////////////////////
//Project DINO
//Joe McManus joe@cert.org
////////////////////////////

include("dinolib.php");
icheck($i);
icheck($s);
icheck($t);
icheck($dport);
icheck($sport);
icheck($h);

$ip=ipcheck($ip);
$sip=ipcheck($sip);
$dip=ipcheck($dip);

include 'open-flash/php-ofc-library/open-flash-chart.php';
$line_array=array();

switch($t) {
	default:
	case "1":
		$start=date('Y/m/d:H',  strtotime("-24 hours"));
		$end=date('Y/m/d:H', strtotime("now"));
		$time="--start-date=" . $start . " --end-date=" . $end;
	break;
	case "2":
		$start=date('Y/m/d:H',  strtotime("-7 days"));
		$end=date('Y/m/d:H', strtotime("now"));
		$time="--start-date=" . $start . " --end-date=" . $end;
	break;
	case "3":
		$start=date('Y/m/d:H',  strtotime("-1 months"));
		$end=date('Y/m/d:H', strtotime("now"));
		$time="--start-date=" . $start . " --end-date=" . $end;
	break;

}

switch($i) { 
	
        case "0": //Unique Hosts
                $cmd="$silkbin/rwfilter --proto=0- --type=all $time --pass=stdout | $silkbin/rwstats --sip  --bytes  --count=25 --no-titles --delimited=, ";
                $title="Top Talkers by Kilobytes";
                $xlabel ='IP Address';
                $ylabel ='Traffic in kB';
                $target=10;
		$type="bybytes";
		$steps="";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip);
        break;	
	case "2": //Incoming Connections
                $cmd="$silkbin/rwfilter --proto=0- --type=in,inweb  $time --pass=stdout | $silkbin/rwstats --count=25 --fields=sip,dip,sport,dport --bytes --no-titles --delimited=,";
		$title="Top Incoming Connctions";
		$xlabel='IP Address | Port';
		$ylabel = 'Traffic in kB';
                $target=10;
		$type="byflows";
		$steps="";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip);
	break;

	case "3": //Outgoing Connections
		$cmd="$silkbin/rwfilter --proto=0- --type=out,outweb $time --pass=stdout | $silkbin/rwstats --count=25 --fields=sip,dip,sport,dport --bytes --no-titles --delimited=, ";
		$title="Top Outgoing Connctions";
		$xlabel='IP Address | Port';
		$ylabel = 'Traffic in kB';
                $target=10;
		$type="byflows";
		$steps="";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip);
	break;

	case "4": //Unique Hosts
		$cmd="$silkbin/rwfilter --proto=0- --type=out,outweb $time --pass=stdout | $silkbin/rwuniq --fields=sip --dip-distinct  --no-titles --delimited=, | sort -nr -k 2 -t ',' | head -25";
		$title="Unique Hosts Visited by Client";
                $target=13;
		$xlabel='IP Address | Port';
		$ylabel='# of Hosts Visited';
		$type="uniquehosts";
		$steps="";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip);
	break;

	case "5":  //Traffic by Hour
		if ($ip == null) {	
			$cmd="$silkbin/rwfilter  --pass=stdout $time --type=all  --proto=0- | $silkbin/rwcount  --bin-size=3600 --no-titles --delimited=,";
			$title="Traffic by Hour";
		} else { 
			$cmd="$silkbin/rwfilter  --pass=stdout --any-address=$ip $time --type=all  --proto=0- | $silkbin/rwcount  --bin-size=3600 --no-titles --delimited=,";
			$title="Traffic by Hour for $ip";
		}
		if (($ip == null)  && ($h != null)) { 
			$time=shtime($h);
			$cmd="$silkbin/rwfilter  --pass=stdout --start-date=$time --type=all --proto=0- | $silkbin/rwcount  --bin-size=3600 --no-titles --delimited=,";
			$title="Traffic by Hour for $time";
		}
		
		$target="11";
		$ylabel="Hour";
		$xlabel="Traffic in kB";
		$type="daily";
		$steps="";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip);

		break;

	case "6":  //Topt dPorts
		$cmd="$silkbin/rwfilter --proto=0- --type=out,outweb $time --pass=stdout  | $silkbin/rwstats --dport  --count=10 --bytes  --no-titles --delimited=,";
		$title="Top Ports";
		piechart($cmd, $title);
		
		break;

	case "10": //hourly ip search
		if ($ip != null && $h == null ) {	
			$cmd="$silkbin/rwfilter --proto=0- --type=all $time --any-address=$ip --pass=stdout  | $silkbin/rwcount --bin-size=3600 --no-titles --delimited=,";
			$title="Traffic for $ip";
		} elseif (($ip != null) && ($h != null)) {	
			$shelltime=shtime($h);
			$cmd="$silkbin/rwfilter --proto=0- --type=all --start-date=$shelltime --any-address=$ip --pass=stdout  | $silkbin/rwcount --bin-size=3600 --no-titles --delimited=,";
			$title="Traffic for $ip $h";
		} else {
			$cmd="$silkbin/rwfilter --proto=0- --type=all $time --saddress=$sip -sport=$sport --daddress=$dip --dport=$dport --pass=stdout  | $silkbin/rwcount --bin-size=3600 --no-titles --delimited=,";
			$title="Traffic for $sip:$sport / $dip:$dport";
		}
                $xlabel='Hour';
		$ylabel='Traffic in kB';
                $target=11;
		$type="hourly";
		$steps="";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip, $sip, $sport, $dip, $dport);

                break;

	case "11": //minutes ip search
		$time=shtime($h);
		if ($ip != null) {	
			$cmd="$silkbin/rwfilter --proto=0- --type=all  --any-address=$ip --start-date=$time --pass=stdout  | $silkbin/rwcount --bin-size=60 --no-titles --delimited=,";
			$title="Traffic for $ip @ $time";
		} elseif ($sip != null ) { 
			$cmd="$silkbin/rwfilter --proto=0- --type=all --saddress=$sip -sport=$sport --daddress=$dip --dport=$dport  --start-date=$time  --pass=stdout  | $silkbin/rwcount --bin-size=60 --no-titles --delimited=,";
			$title="Traffic for $sip:$sport / $dip:$dport @ $time";
		} else {
			$cmd="$silkbin/rwfilter --proto=0- --type=all  --start-date=$time --pass=stdout  | $silkbin/rwcount --bin-size=60 --no-titles --delimited=,";
			$title="Traffic for $ip @ $time";

		}
		if ($ip == null) { 
                	$target='17';
		} else { 
			$target=13;	
		}
			
		$xlabel="Time";
		$ylabel='Traffic in kB';
		$type="minutes";
		$steps="5";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip);


                break;

	case "15": // Three Lines 1 Week

		$cmd1="$silkbin/rwfilter --proto=0- --type=all $currentWeekTime --pass=stdout  | $silkbin/rwcount --bin-size=86400 --no-titles --delimited=,";
		$cmd2="$silkbin/rwfilter --proto=0- --type=all $backOneWeekTime --pass=stdout  | $silkbin/rwcount --bin-size=86400 --no-titles --delimited=,";
		$cmd3="$silkbin/rwfilter --proto=0- --type=all $backTwoWeekTime  --pass=stdout  | $silkbin/rwcount --bin-size=86400 --no-titles --delimited=,";
		$title="Weekly Traffic Overlays";	
		$target=5;
		$title1="Current Week";
		$title2="Prior Week";
		$title3="2 Weeks Back";
		multilinechart($cmd1, $cmd2, $cmd3, $title, $target, $title1, $title2, $title3);
		break; 
	
	case "16": // Three Lines 1 Month

		$cmd1="$silkbin/rwfilter --proto=0- --type=all $currentMonthTime --pass=stdout  | $silkbin/rwcount --bin-size=86400 --no-titles --delimited=,";
		$cmd2="$silkbin/rwfilter --proto=0- --type=all $backOneMonthTime --pass=stdout  | $silkbin/rwcount --bin-size=86400 --no-titles --delimited=,";
		$cmd3="$silkbin/rwfilter --proto=0- --type=all $backTwoMonthTime  --pass=stdout  | $silkbin/rwcount --bin-size=86400 --no-titles --delimited=,";
		$title="Monthly Traffic Overlays";	
		$target=5;
		$title1="Current Month";
		$title2="Prior Month";
		$title3="2 Months Prior";
		multilinechart($cmd1, $cmd2, $cmd3, $title, $target, $title1, $title2, $title3);
		break; 
        case "17": //Unique Hosts for hour
		$time=shtime($h);
                $cmd="$silkbin/rwfilter --proto=0- --type=all --start-date=$time --pass=stdout | $silkbin/rwstats --sip  --bytes  --count=25 --no-titles --delimited=, ";
                $title="Top Talkers by Kilobytes for $time";
                $xlabel ='IP Address';
                $ylabel ='Traffic in kB';
                $target=13;
		$type="bybytes";
		$steps="";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip);
        break;	
}

//Check sub charts for ip report
switch($s) {
	case "1": // 24 Hour IP Traffic usage
		$bin=3600;
		$cmd="$silkbin/rwfilter --proto=0- --type=all $time --any-address=$ip --pass=stdout  | $silkbin/rwcount --bin-size=$bin --no-titles --delimited=,";
		$title="Hourly Traffic for $ip";
		$xlabel="Hour";
		$ylabel="Kilobytes";
		$target="11";
		$type="summaryhour";
		$steps=2;
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip, '', '', '', '');
		
	case "2": // 7 Day IP Traffic usage
		$bin=86400;
		$cmd="$silkbin/rwfilter --proto=0- --type=all $time --any-address=$ip --pass=stdout  | $silkbin/rwcount --bin-size=$bin --no-titles --delimited=,";
                $title="Daily Traffic for $ip";
                $xlabel="Day";
		$ylabel="Kilobytes";
		$target="10";
		$type="summaryday";
		$steps="";
		barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip, '', '', '', '');
	case "3": // Monthly IP Traffic usage
		$bin=86400;
		$cmd="$silkbin/rwfilter --proto=0- --type=all $time --any-address=$ip --pass=stdout  | $silkbin/rwcount --bin-size=$bin --no-titles --delimited=,";
		$title="Monthly Traffic for $ip";
                $xlabel="Day";
                $ylabel="Kilobytes";
                $target="10";
		$type="summaryday";
		$steps=5;
                barchart($cmd, $title, $xlabel, $ylabel, $target , $type, $steps, $ip, '', '', '', '');


                break;

	case "4":  //Top Ports
		if ($ip == null) {
			$cmd="$silkbin/rwfilter --proto=0- --type=all $time --pass=stdout  | $silkbin/rwstats --dport  --count=10 --bytes  --no-titles --delimited=,";
		} else { 
			$cmd="$silkbin/rwfilter --proto=0- --type=all --any-address=$ip $time --pass=stdout  | $silkbin/rwstats --dport  --count=10 --bytes  --no-titles --delimited=,";
		}
		
		$title="Top Ports"; 
		piechart($cmd, $title) ;		
		break;

	case "5": // 1 minute using rwfile
		$bin=60;
		$cmd="$silkbin/rwfilter --proto=0- $rwfile --pass=stdout | $silkbin/rwcount --bin-size=$bin --no-titles --delimited=,";
		$title="Traffic Over Time";
		$xlabel="Time";
		$ylabel="Kilobytes";
		$type="bybytes";
		$steps=2;
		rwchart($cmd, $title, $xlabel, $ylabel, $type, $steps);
		
	case "6": // Traffic by flows
		$bin=3600;
		$cmd="$silkbin/rwfilter --proto=0- $rwfile --pass=stdout  | $silkbin/rwstats --count=25 --fields=sip,dip,sport,dport --bytes --no-titles --delimited=,";
                $title="Traffic By Flows";
                $xlabel="Host|Port";
		$ylabel="Kilobytes";
		$type="byflows";
		$steps="2";
		rwchart($cmd, $title, $xlabel, $ylabel, $type, $steps);
	case "7": //Top Unique Hosts
		$cmd="$silkbin/rwfilter --proto=0- $rwfile --pass=stdout | $silkbin/rwuniq --fields=sip --dip-distinct  --no-titles --delimited=, | sort -nr -k 2 -t ',' | head -25";
                $title="Unique Hosts Visited by Client";
                $xlabel='Host';
                $ylabel='# of Hosts Visited';
                $type="uniquehosts";
                $steps="2";
		rwchart($cmd, $title, $xlabel, $ylabel, $type, $steps);
                break;

	case "8":  //Top Ports
		$cmd="$silkbin/rwfilter --proto=0- $rwfile --pass=stdout  | $silkbin/rwstats --dport  --count=10 --bytes  --no-titles --delimited=,";
		$title="Top Ports"; 
		piechart($cmd, $title) ;		
		break;
	case "9": // 1 minute using rwfile
		$bin=60;
		$cmd="$silkbin/rwfilter --proto=0- $rwfile --pass=stdout | $silkbin/rwstats --sip  --bytes  --count=25 --no-titles --delimited=, ";
		$title="Traffic By Source IP";
		$xlabel="Host";
		$ylabel="Kilobytes";
		$type="bybytes";
		$steps=2;
		rwchart($cmd, $title, $xlabel, $ylabel, $type, $steps);
		break;
		
}

?>
